"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChangePasswordDialog = void 0;
var react_1 = __importStar(require("react"));
var constants_1 = require("../../constants");
var contexts_1 = require("../../contexts");
var ChangePasswordDialogBase_1 = require("./ChangePasswordDialogBase");
var CheckCircle_1 = __importDefault(require("@mui/icons-material/CheckCircle"));
var react_i18next_1 = require("react-i18next");
var useErrorManager_1 = require("../../contexts/ErrorContext/useErrorManager");
/**
 * Component that renders a dialog with textField to enter current password and a change password form with a new password and confirm password inputs.
 * It includes callbacks so you can respond to changes in the inputs.
 *
 * @param {ChangePasswordDialogProps} props - props of changePassword dailog
 *
 * @category Component
 */
var ChangePasswordDialog = function (props) {
    var _a;
    var t = (0, react_i18next_1.useTranslation)().t;
    var passwordRef = (0, react_1.useRef)(null);
    var confirmRef = (0, react_1.useRef)(null);
    var open = props.open, _b = props.dialogTitle, dialogTitle = _b === void 0 ? t('bluiAuth:CHANGE_PASSWORD.PASSWORD') : _b, _c = props.dialogDescription, dialogDescription = _c === void 0 ? t('bluiAuth:CHANGE_PASSWORD.PASSWORD_INFO') : _c, _d = props.currentPasswordLabel, currentPasswordLabel = _d === void 0 ? t('bluiCommon:LABELS.CURRENT_PASSWORD') : _d, _e = props.previousLabel, previousLabel = _e === void 0 ? t('bluiCommon:ACTIONS.BACK') : _e, _f = props.nextLabel, nextLabel = _f === void 0 ? t('bluiCommon:ACTIONS.OKAY') : _f, onPrevious = props.onPrevious, onFinish = props.onFinish, PasswordProps = props.PasswordProps, loading = props.loading, currentPasswordTextFieldProps = props.currentPasswordTextFieldProps, _g = props.slots, slots = _g === void 0 ? {} : _g, _h = props.slotProps, slotProps = _h === void 0 ? {} : _h;
    var _j = (0, react_1.useState)(''), currentInput = _j[0], setCurrentInput = _j[1];
    var _k = (0, react_1.useState)(''), passwordInput = _k[0], setPasswordInput = _k[1];
    var _l = (0, react_1.useState)(''), confirmInput = _l[0], setConfirmInput = _l[1];
    var _m = (0, react_1.useState)(loading), isLoading = _m[0], setIsLoading = _m[1];
    var _o = (0, react_1.useState)(false), showSuccessScreen = _o[0], setShowSuccessScreen = _o[1];
    var _p = (0, contexts_1.useAuthContext)(), actions = _p.actions, navigate = _p.navigate, routeConfig = _p.routeConfig;
    var _q = (0, useErrorManager_1.useErrorManager)(), triggerError = _q.triggerError, errorManagerConfig = _q.errorManagerConfig;
    var errorDisplayConfig = __assign(__assign(__assign({}, errorManagerConfig), props.errorDisplayConfig), { onClose: function () {
            if (props.errorDisplayConfig && props.errorDisplayConfig.onClose)
                props.errorDisplayConfig.onClose();
            if (errorManagerConfig.onClose)
                errorManagerConfig === null || errorManagerConfig === void 0 ? void 0 : errorManagerConfig.onClose();
        } });
    var _r = (0, react_1.useState)(false), hasVerifyCodeError = _r[0], setHasVerifyCodeError = _r[1];
    var passwordReqs = (_a = PasswordProps === null || PasswordProps === void 0 ? void 0 : PasswordProps.passwordRequirements) !== null && _a !== void 0 ? _a : (0, constants_1.defaultPasswordRequirements)(t);
    var updateFields = (0, react_1.useCallback)(function (fields) {
        setPasswordInput(fields.password);
        setConfirmInput(fields.confirm);
    }, [setPasswordInput, setConfirmInput]);
    var areValidMatchingPasswords = (0, react_1.useCallback)(function () {
        if ((passwordReqs === null || passwordReqs === void 0 ? void 0 : passwordReqs.length) === 0) {
            return confirmInput === passwordInput;
        }
        for (var i = 0; i < passwordReqs.length; i++) {
            if (!new RegExp(passwordReqs[i].regex).test(passwordInput))
                return false;
        }
        return confirmInput === passwordInput;
    }, [passwordReqs, passwordInput, confirmInput]);
    var checkPasswords = currentInput !== '' && passwordInput !== '' && confirmInput !== '' && areValidMatchingPasswords();
    var changePasswordSubmit = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var _error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!checkPasswords) return [3 /*break*/, 5];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    setIsLoading(true);
                    return [4 /*yield*/, actions.changePassword(currentInput, passwordInput)];
                case 2:
                    _a.sent();
                    if (props.showSuccessScreen === false) {
                        onFinish === null || onFinish === void 0 ? void 0 : onFinish();
                    }
                    setShowSuccessScreen(true);
                    return [3 /*break*/, 5];
                case 3:
                    _error_1 = _a.sent();
                    setHasVerifyCodeError(true);
                    triggerError(_error_1);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [
        checkPasswords,
        currentInput,
        passwordInput,
        actions,
        setIsLoading,
        onFinish,
        props.showSuccessScreen,
        triggerError,
    ]);
    var passwordProps = __assign(__assign({ newPasswordLabel: t('bluiAuth:CHANGE_PASSWORD.NEW_PASSWORD'), confirmPasswordLabel: t('bluiAuth:CHANGE_PASSWORD.CONFIRM_NEW_PASSWORD'), passwordRef: passwordRef, confirmRef: confirmRef, initialNewPasswordValue: passwordInput, initialConfirmPasswordValue: confirmInput, passwordRequirements: passwordReqs, passwordNotMatchError: t('bluiCommon:FORMS.PASS_MATCH_ERROR') }, PasswordProps), { onPasswordChange: function (passwordData) {
            var _a;
            updateFields(passwordData);
            (_a = PasswordProps === null || PasswordProps === void 0 ? void 0 : PasswordProps.onPasswordChange) === null || _a === void 0 ? void 0 : _a.call(PasswordProps, passwordData);
        }, onSubmit: function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, changePasswordSubmit()];
                    case 1:
                        _b.sent();
                        (_a = PasswordProps === null || PasswordProps === void 0 ? void 0 : PasswordProps.onSubmit) === null || _a === void 0 ? void 0 : _a.call(PasswordProps);
                        return [2 /*return*/];
                }
            });
        }); } });
    return (react_1.default.createElement(ChangePasswordDialogBase_1.ChangePasswordDialogBase, { open: open, loading: isLoading, dialogTitle: dialogTitle, dialogDescription: dialogDescription, currentPasswordLabel: currentPasswordLabel, previousLabel: previousLabel, nextLabel: nextLabel, currentPasswordChange: function (currentPwd) {
            var _a;
            setCurrentInput(currentPwd);
            (_a = props === null || props === void 0 ? void 0 : props.currentPasswordChange) === null || _a === void 0 ? void 0 : _a.call(props, currentPwd);
        }, enableButton: checkPasswords, onPrevious: onPrevious, PasswordProps: passwordProps, currentPasswordTextFieldProps: currentPasswordTextFieldProps, onSubmit: function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, changePasswordSubmit()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }, slots: slots, slotProps: {
            SuccessScreen: __assign({ EmptyStateProps: {
                    icon: react_1.default.createElement(CheckCircle_1.default, { color: "primary", sx: { fontSize: 100 } }),
                    title: t('bluiAuth:PASSWORD_RESET.SUCCESS_MESSAGE'),
                    description: t('bluiAuth:CHANGE_PASSWORD.SUCCESS_MESSAGE'),
                }, onDismiss: function () {
                    onFinish === null || onFinish === void 0 ? void 0 : onFinish();
                }, WorkflowCardActionsProps: {
                    showPrevious: false,
                    fullWidthButton: true,
                    showNext: true,
                    nextLabel: t('bluiCommon:ACTIONS.DONE'),
                    onNext: function () {
                        onFinish === null || onFinish === void 0 ? void 0 : onFinish();
                    },
                } }, slotProps.SuccessScreen),
        }, showSuccessScreen: showSuccessScreen, errorDisplayConfig: __assign(__assign({}, errorDisplayConfig), { onClose: hasVerifyCodeError
                ? function () {
                    navigate(routeConfig.LOGIN);
                    // eslint-disable-next-line no-unused-expressions
                    errorDisplayConfig.onClose;
                }
                : errorDisplayConfig.onClose }) }));
};
exports.ChangePasswordDialog = ChangePasswordDialog;
