"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OktaAuthContextProvider = exports.OktaAuthContext = exports.useOktaAuthContext = void 0;
var react_1 = require("react");
var context_1 = require("./context");
Object.defineProperty(exports, "OktaAuthContext", { enumerable: true, get: function () { return context_1.OktaAuthContext; } });
var provider_1 = require("./provider");
Object.defineProperty(exports, "OktaAuthContextProvider", { enumerable: true, get: function () { return provider_1.OktaAuthContextProvider; } });
/**
 * Hook to get top level data in okta authentication workflow
 *
 * @category Hooks
 * @private
 * @internal
 */
var useOktaAuthContext = function () {
    var context = (0, react_1.useContext)(context_1.OktaAuthContext);
    if (context === null) {
        throw new Error('useOktaAuthContext must be used within OktaAuthContextProvider');
    }
    return context;
};
exports.useOktaAuthContext = useOktaAuthContext;
