"use strict";
/**
 * @packageDocumentation
 * @module OktaAuthContextProvider
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OktaAuthContextProvider = void 0;
var react_1 = __importStar(require("react"));
var context_1 = require("./context");
var react_i18next_1 = require("react-i18next");
var ErrorContext_1 = require("../ErrorContext");
var AuthDictionaries_1 = require("../AuthContext/AuthDictionaries");
var SharedDictionaries_1 = require("../SharedDictionaries");
var i18nAuthInstance_1 = require("../AuthContext/i18nAuthInstance");
var OktaAuthContextProviderContent = function (props) {
    var _a;
    var children = props.children, errorConfig = props.errorConfig, oktaAuthContextProps = __rest(props, ["children", "errorConfig"]);
    var t = (0, react_i18next_1.useTranslation)().t;
    var mergedErrorConfig = __assign(__assign({ t: t, title: 'bluiCommon:MESSAGES.ERROR', error: 'bluiAuth:LOGIN.INVALID_CREDENTIALS' }, errorConfig), { dialogConfig: __assign({ dismissLabel: 'bluiCommon:ACTIONS.OKAY' }, ((_a = errorConfig === null || errorConfig === void 0 ? void 0 : errorConfig.dialogConfig) !== null && _a !== void 0 ? _a : {})) });
    return (react_1.default.createElement(context_1.OktaAuthContext.Provider, { value: __assign({}, oktaAuthContextProps) },
        react_1.default.createElement(ErrorContext_1.ErrorContext.Provider, { value: mergedErrorConfig }, children)));
};
var OktaAuthContextProvider = function (props) {
    var _a;
    var i18nInstance = (_a = props.i18n) !== null && _a !== void 0 ? _a : i18nAuthInstance_1.i18nAuthInstance;
    var language = props.language, _b = props.i18n, i18n = _b === void 0 ? i18nInstance : _b, children = props.children, other = __rest(props, ["language", "i18n", "children"]);
    if (props.i18n) {
        i18n.addResourceBundle('zh', 'bluiAuth', AuthDictionaries_1.AuthDictionaries.chinese.translation, true, false);
        i18n.addResourceBundle('zh', 'bluiCommon', SharedDictionaries_1.SharedDictionaries.chinese.translation, true, false);
        i18n.addResourceBundle('zh', 'bluiAuth', AuthDictionaries_1.AuthDictionaries.english.translation, true, false);
        i18n.addResourceBundle('en', 'bluiCommon', SharedDictionaries_1.SharedDictionaries.english.translation, true, false);
        i18n.addResourceBundle('zh', 'bluiAuth', AuthDictionaries_1.AuthDictionaries.french.translation, true, false);
        i18n.addResourceBundle('fr', 'bluiCommon', SharedDictionaries_1.SharedDictionaries.french.translation, true, false);
        i18n.addResourceBundle('zh', 'bluiAuth', AuthDictionaries_1.AuthDictionaries.portuguese.translation, true, false);
        i18n.addResourceBundle('pt', 'bluiCommon', SharedDictionaries_1.SharedDictionaries.portuguese.translation, true, false);
        i18n.addResourceBundle('zh', 'bluiAuth', AuthDictionaries_1.AuthDictionaries.spanish.translation, true, false);
        i18n.addResourceBundle('es', 'bluiCommon', SharedDictionaries_1.SharedDictionaries.spanish.translation, true, false);
    }
    (0, react_1.useEffect)(function () {
        void i18n.changeLanguage(language);
    }, [i18n, language]);
    return (react_1.default.createElement(react_i18next_1.I18nextProvider, { i18n: i18n },
        react_1.default.createElement(OktaAuthContextProviderContent, __assign({}, other, { language: language }), children)));
};
exports.OktaAuthContextProvider = OktaAuthContextProvider;
