"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExistingAccountSuccessScreen = void 0;
var react_1 = __importDefault(require("react"));
var icons_material_1 = require("@mui/icons-material");
var contexts_1 = require("../../contexts");
var SuccessScreen_1 = require("../SuccessScreen");
var react_i18next_1 = require("react-i18next");
/**
 * Full Screen component that renders a Success Screen for the accounts which are already exists in the records
 *
 * @param {SuccessScreenProps} props - props of SuccessScreen
 *
 * @category Component
 */
var ExistingAccountSuccessScreen = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = (0, contexts_1.useRegistrationContext)(), navigate = _a.navigate, routeConfig = _a.routeConfig;
    var _b = props.canDismiss, canDismiss = _b === void 0 ? true : _b, _c = props.onDismiss, onDismiss = _c === void 0 ? function () { return navigate(routeConfig.LOGIN); } : _c, WorkflowCardHeaderProps = props.WorkflowCardHeaderProps, WorkflowCardActionsProps = props.WorkflowCardActionsProps, EmptyStateProps = props.EmptyStateProps, otherExistingAccountSuccessScreenProps = __rest(props, ["canDismiss", "onDismiss", "WorkflowCardHeaderProps", "WorkflowCardActionsProps", "EmptyStateProps"]);
    var workflowCardHeaderProps = __assign({ title: t('bluiRegistration:REGISTRATION.STEPS.COMPLETE') }, WorkflowCardHeaderProps);
    var workflowCardActionsProps = __assign(__assign({ nextLabel: t('bluiCommon:ACTIONS.CONTINUE'), showNext: true, canGoNext: canDismiss, fullWidthButton: true }, WorkflowCardActionsProps), { onNext: function () {
            var _a;
            onDismiss();
            (_a = WorkflowCardActionsProps === null || WorkflowCardActionsProps === void 0 ? void 0 : WorkflowCardActionsProps.onNext) === null || _a === void 0 ? void 0 : _a.call(WorkflowCardActionsProps);
        } });
    var emptyStateProps = __assign({ icon: react_1.default.createElement(icons_material_1.Person, { color: 'primary', sx: { fontSize: 100, mb: 2 } }), title: t('bluiCommon:MESSAGES.WELCOME'), description: t('bluiRegistration:REGISTRATION.SUCCESS_EXISTING') }, EmptyStateProps);
    return (react_1.default.createElement(SuccessScreen_1.SuccessScreenBase, __assign({ WorkflowCardHeaderProps: workflowCardHeaderProps, WorkflowCardActionsProps: workflowCardActionsProps, EmptyStateProps: emptyStateProps }, otherExistingAccountSuccessScreenProps)));
};
exports.ExistingAccountSuccessScreen = ExistingAccountSuccessScreen;
