"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OktaRedirectLoginScreenBase = void 0;
var react_1 = __importDefault(require("react"));
var WorkflowCard_1 = require("../../components/WorkflowCard");
var WorkflowCardBody_1 = require("../../components/WorkflowCard/WorkflowCardBody");
var material_1 = require("@mui/material");
var styles_1 = require("../../styles");
var cybersecurity_certified_png_1 = __importDefault(require("../../assets/images/cybersecurity_certified.png"));
var base_1 = require("@mui/base");
var utilityClasses_1 = require("./utilityClasses");
var useUtilityClasses = function (ownerState) {
    var classes = ownerState.classes;
    var slots = {
        root: ['root'],
        projectImageWrapper: ['projectImageWrapper'],
        loginButtonWrapper: ['loginButtonWrapper'],
        loginButton: ['loginButton'],
        forgotPasswordWrapper: ['forgotPasswordWrapper'],
        forgotPasswordLabel: ['forgotPasswordLabel'],
        selfRegisterWrapper: ['selfRegisterWrapper'],
        selfRegisterInstructionLabel: ['selfRegisterInstructionLabel'],
        selfRegisterLabel: ['selfRegisterLabel'],
        contactSupportWrapper: ['contactSupportWrapper'],
        contactSupportLabel: ['contactSupportLabel'],
        cyberSecurityBadgeWrapper: ['cyberSecurityBadgeWrapper'],
        cyberSecurityBadge: ['cyberSecurityBadge'],
    };
    return (0, base_1.unstable_composeClasses)(slots, utilityClasses_1.getOktaRedirectLoginScreenUtilityClass, classes);
};
/**
 * Component that renders an okta login screen.
 *
 * @param {OktaRedirectLoginScreenProps} props - props of OktaRedirectLoginScreen base component
 *
 * @category Component
 */
var OktaRedirectLoginScreenBase = function (props) {
    var defaultClasses = useUtilityClasses(props);
    var header = props.header, projectImage = props.projectImage, loginButtonLabel = props.loginButtonLabel, onLogin = props.onLogin, showForgotPassword = props.showForgotPassword, forgotPasswordLabel = props.forgotPasswordLabel, onForgotPassword = props.onForgotPassword, showContactSupport = props.showContactSupport, showCyberSecurityBadge = props.showCyberSecurityBadge, showSelfRegistration = props.showSelfRegistration, selfRegisterButtonLabel = props.selfRegisterButtonLabel, selfRegisterInstructions = props.selfRegisterInstructions, onSelfRegister = props.onSelfRegister, contactSupportLabel = props.contactSupportLabel, footer = props.footer, onContactSupport = props.onContactSupport, otherProps = __rest(props, ["header", "projectImage", "loginButtonLabel", "onLogin", "showForgotPassword", "forgotPasswordLabel", "onForgotPassword", "showContactSupport", "showCyberSecurityBadge", "showSelfRegistration", "selfRegisterButtonLabel", "selfRegisterInstructions", "onSelfRegister", "contactSupportLabel", "footer", "onContactSupport"]);
    var handleOnLogin = function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!onLogin) return [3 /*break*/, 2];
                    return [4 /*yield*/, onLogin()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); };
    var handleForgotPassword = function () {
        if (onForgotPassword)
            onForgotPassword();
    };
    var handleSelfRegister = function () {
        if (onSelfRegister)
            onSelfRegister();
    };
    var handleContactSupport = function () {
        if (onContactSupport)
            onContactSupport();
    };
    return (react_1.default.createElement(WorkflowCard_1.WorkflowCard, __assign({ className: defaultClasses.root, "data-testid": defaultClasses.root }, otherProps),
        react_1.default.createElement(WorkflowCardBody_1.WorkflowCardBody, { sx: {
                py: { xs: 4, sm: 4, md: 4 },
                px: { xs: 4, sm: 8, md: 8 },
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'space-around',
            } },
            header,
            react_1.default.createElement(material_1.Box, { sx: { display: 'flex', maxWidth: '100%', mb: 6 }, className: defaultClasses.projectImageWrapper, "data-testid": defaultClasses.projectImageWrapper }, projectImage),
            react_1.default.createElement(material_1.Box, { sx: {
                    my: 5,
                }, className: defaultClasses.loginButtonWrapper, "data-testid": defaultClasses.loginButtonWrapper },
                react_1.default.createElement(material_1.Button, { className: defaultClasses.loginButton, "data-testid": defaultClasses.loginButton, onClick: function () {
                        void handleOnLogin();
                    }, variant: "contained", color: "primary", sx: {
                        width: '100%',
                    } }, loginButtonLabel || 'Sign In With Okta')),
            showForgotPassword && (react_1.default.createElement(material_1.Box, { sx: { display: 'flex', justifyContent: 'center', textAlign: 'center' }, className: defaultClasses.forgotPasswordWrapper, "data-testid": defaultClasses.forgotPasswordWrapper },
                react_1.default.createElement(material_1.Typography, { variant: "body2", sx: styles_1.LinkStyles, onClick: handleForgotPassword, className: defaultClasses.forgotPasswordLabel, "data-testid": defaultClasses.forgotPasswordLabel }, forgotPasswordLabel || 'Forgot your password?'))),
            showSelfRegistration && (react_1.default.createElement(material_1.Box, { sx: {
                    display: 'flex',
                    justifyContent: 'center',
                    alignItems: 'center',
                    flexDirection: 'column',
                    textAlign: 'center',
                }, className: defaultClasses.selfRegisterWrapper, "data-testid": defaultClasses.selfRegisterWrapper },
                react_1.default.createElement(material_1.Typography, { variant: "body2", className: defaultClasses.selfRegisterInstructionLabel, "data-testid": defaultClasses.selfRegisterInstructionLabel }, selfRegisterInstructions || 'Need an account?'),
                react_1.default.createElement(material_1.Typography, { variant: "body2", sx: styles_1.LinkStyles, onClick: handleSelfRegister, className: defaultClasses.selfRegisterLabel, "data-testid": defaultClasses.selfRegisterLabel }, selfRegisterButtonLabel || 'Register now!'))),
            showContactSupport && (react_1.default.createElement(material_1.Box, { sx: { display: 'flex', justifyContent: 'center', textAlign: 'center' }, className: defaultClasses.contactSupportWrapper, "data-testid": defaultClasses.contactSupportWrapper },
                react_1.default.createElement(material_1.Typography, { variant: "body2", sx: styles_1.LinkStyles, onClick: handleContactSupport }, contactSupportLabel || 'Contact Support'))),
            footer && react_1.default.createElement(material_1.Box, { sx: { display: 'flex', justifyContent: 'center' } }, footer),
            showCyberSecurityBadge && (react_1.default.createElement(material_1.Box, { sx: { display: 'flex', justifyContent: 'center' }, className: defaultClasses.cyberSecurityBadgeWrapper, "data-testid": defaultClasses.cyberSecurityBadgeWrapper },
                react_1.default.createElement("img", { src: cybersecurity_certified_png_1.default, alt: "Cyber Security Badge", style: { width: '100px' } }))))));
};
exports.OktaRedirectLoginScreenBase = OktaRedirectLoginScreenBase;
